$(function(){
$("#chart").dxChart({
title: "Population Pyramid For Norway 2016",
dataSource: dataSource,
rotated: true,
barGroupWidth: 18,
commonSeriesSettings: {
type: "stackedbar",
argumentField: "age"
},
series: [{
valueField: "male",
name: "Male",
color: "#3F7FBF"
}, {
valueField: "female",
name: "Female",
color: "#F87CCC"
}],
tooltip: {
enabled: true,
customizeTooltip: function () {
return {
text: Math.abs(this.valueText)
};
}
},
valueAxis: {
label: {
customizeText: function () {
return Math.abs(this.value) + '%';
}
}
},
legend: {
verticalAlignment: "bottom",
horizontalAlignment: "center",
margin: { left: 50 }
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.6/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="chart"></div>
</div>
</body>
</html>
#chart {
height: 549px;
width: 820px;
margin: 0 auto;
}
var dataSource = [{
age: "0-4",
male: -3.1,
female: 2.9
},{
age: "5-9",
male: -3.1,
female: 3.0
},{
age: "10-14",
male: -3.0,
female: 2.9
},{
age: "15-19",
male: -3.2,
female: 3.0
},{
age: "20-24",
male: -3.5,
female: 3.3
},{
age: "25-29",
male: -3.5,
female: 3.4
},{
age: "30-34",
male: -3.5,
female: 3.3
},{
age: "35-39",
male: -3.3,
female: 3.1
},{
age: "40-44",
male: -3.7,
female: 3.4
},{
age: "45-49",
male: -3.8,
female: 3.5
},{
age: "50-54",
male: -3.4,
female: 3.2
},{
age: "55-59",
male: -3.1,
female: 3.0
},{
age: "60-64",
male: -2.7,
female: 2.7
},{
age: "65-69",
male: -2.9,
female: 2.9
},{
age: "70-74",
male: -2,
female: 2.1
},{
age: "75-79",
male: -1.2,
female: 1.4
},{
age: "80-84",
male: -0.8,
female: 1.2
},{
age: "85-89",
male: -0.5,
female: 0.8
},{
age: "90-94",
male: -0.2,
female: 0.5
},{
age: "95+",
male: 0,
female: 0.1
}];

import React from 'react';
import Chart, {
CommonSeriesSettings,
ValueAxis,
Label,
Legend,
Series,
Tooltip,
Margin,
type ChartTypes,
} from 'devextreme-react/chart';
import { dataSource } from './data.ts';
function customizeTooltip(e: ChartTypes.CommonPointInfo) {
return { text: Math.abs(Number(e.valueText)) };
}
function customizeLabel(e: { value: Date | number | string }) {
return `${Math.abs(e.value as number)}%`;
}
function App() {
return (
<Chart
title="Population Pyramid For Norway 2024"
dataSource={dataSource}
id="chart"
rotated={true}
barGroupWidth={18}
>
<CommonSeriesSettings
type="stackedbar"
argumentField="age"
/>
<Series
valueField="male"
name="Male"
color="#3F7FBF"
/>
<Series
valueField="female"
name="Female"
color="#F87CCC"
/>
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip}
/>
<ValueAxis>
<Label customizeText={customizeLabel} />
</ValueAxis>
<Legend
verticalAlignment="bottom"
horizontalAlignment="center"
>
<Margin left={50} />
</Legend>
</Chart>
);
}
export default App;
import React from 'react';
import Chart, {
CommonSeriesSettings,
ValueAxis,
Label,
Legend,
Series,
Tooltip,
Margin,
} from 'devextreme-react/chart';
import { dataSource } from './data.js';
function customizeTooltip(e) {
return { text: Math.abs(Number(e.valueText)) };
}
function customizeLabel(e) {
return `${Math.abs(e.value)}%`;
}
function App() {
return (
<Chart
title="Population Pyramid For Norway 2024"
dataSource={dataSource}
id="chart"
rotated={true}
barGroupWidth={18}
>
<CommonSeriesSettings
type="stackedbar"
argumentField="age"
/>
<Series
valueField="male"
name="Male"
color="#3F7FBF"
/>
<Series
valueField="female"
name="Female"
color="#F87CCC"
/>
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip}
/>
<ValueAxis>
<Label customizeText={customizeLabel} />
</ValueAxis>
<Legend
verticalAlignment="bottom"
horizontalAlignment="center"
>
<Margin left={50} />
</Legend>
</Chart>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const dataSource = [{
age: '0-4',
male: -2.99,
female: 2.83,
}, {
age: '5-9',
male: -2.93,
female: 2.77,
}, {
age: '10-14',
male: -3.04,
female: 2.88,
}, {
age: '15-19',
male: -3.24,
female: 3.09,
}, {
age: '20-24',
male: -3.24,
female: 3.09,
}, {
age: '25-29',
male: -3.15,
female: 3,
}, {
age: '30-34',
male: -3.19,
female: 3.04,
}, {
age: '35-39',
male: -3.38,
female: 3.24,
}, {
age: '40-44',
male: -3.58,
female: 3.42,
}, {
age: '45-49',
male: -3.38,
female: 3.22,
}, {
age: '50-54',
male: -3.1,
female: 2.97,
}, {
age: '55-59',
male: -2.9,
female: 2.83,
}, {
age: '60-64',
male: -2.72,
female: 2.66,
}, {
age: '65-69',
male: -2.34,
female: 2.44,
}, {
age: '70-74',
male: -1.51,
female: 1.68,
}, {
age: '75-79',
male: -1.11,
female: 1.38,
}, {
age: '80-84',
male: -0.84,
female: 1.22,
}, {
age: '85+',
male: -0.48,
female: 1.39,
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const dataSource = [
{
age: '0-4',
male: -2.99,
female: 2.83,
},
{
age: '5-9',
male: -2.93,
female: 2.77,
},
{
age: '10-14',
male: -3.04,
female: 2.88,
},
{
age: '15-19',
male: -3.24,
female: 3.09,
},
{
age: '20-24',
male: -3.24,
female: 3.09,
},
{
age: '25-29',
male: -3.15,
female: 3,
},
{
age: '30-34',
male: -3.19,
female: 3.04,
},
{
age: '35-39',
male: -3.38,
female: 3.24,
},
{
age: '40-44',
male: -3.58,
female: 3.42,
},
{
age: '45-49',
male: -3.38,
female: 3.22,
},
{
age: '50-54',
male: -3.1,
female: 2.97,
},
{
age: '55-59',
male: -2.9,
female: 2.83,
},
{
age: '60-64',
male: -2.72,
female: 2.66,
},
{
age: '65-69',
male: -2.34,
female: 2.44,
},
{
age: '70-74',
male: -1.51,
female: 1.68,
},
{
age: '75-79',
male: -1.11,
female: 1.38,
},
{
age: '80-84',
male: -0.84,
female: 1.22,
},
{
age: '85+',
male: -0.48,
female: 1.39,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 549px;
width: 820px;
margin: 0 auto;
}

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Charts - Bi-Directional Bar Chart

To create a bi-directional bar chart, follow the steps below.

Backend API
<template> <DxChart id="chart" :data-source="dataSource" :rotated="true" :bar-group-width="18" title="Population Pyramid For Norway 2024" > <DxCommonSeriesSettings argument-field="age" type="stackedbar" /> <DxSeries value-field="male" name="Male" color="#3F7FBF" /> <DxSeries value-field="female" name="Female" color="#F87CCC" /> <DxTooltip :enabled="true" :customize-tooltip="customizeTooltip" /> <DxValueAxis> <DxLabel :customize-text="customizeLabel"/> </DxValueAxis> <DxLegend :margin="{left: 50}" vertical-alignment="bottom" horizontal-alignment="center" /> </DxChart> </template> <script setup lang="ts"> import DxChart, { DxCommonSeriesSettings, DxValueAxis, DxLabel, DxLegend, DxSeries, DxTooltip, type DxChartTypes, } from 'devextreme-vue/chart'; import { dataSource } from './data.ts'; const customizeTooltip = (e: DxChartTypes.PointInfo) => ({ text: Math.abs(Number(e.valueText)), }); const customizeLabel = ({ value }: Record<string, any>) => `${Math.abs(value)}%`; </script> <style> #chart { height: 549px; width: 820px; margin: 0 auto; } </style>
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'typescript': { 'exports': 'ts', }, 'vue': { format: 'global', exports: 'Vue', esModule: true, }, 'vuex': { format: 'global', exports: 'Vuex', esModule: true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, 'anti-forgery': { loader: 'demo-ts-loader', }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', 'loaders:': '../../../../shared/loaders/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.40/dist/vue.global.js', '@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js', 'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'loaders:demo-ts-loader.js', 'demo-ts-shared': 'loaders:demo-ts-shared.js', 'vue-loader': 'loaders:demo-vue-loader.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
export const dataSource = [ { age: '0-4', male: -2.99, female: 2.83, }, { age: '5-9', male: -2.93, female: 2.77, }, { age: '10-14', male: -3.04, female: 2.88, }, { age: '15-19', male: -3.24, female: 3.09, }, { age: '20-24', male: -3.24, female: 3.09, }, { age: '25-29', male: -3.15, female: 3, }, { age: '30-34', male: -3.19, female: 3.04, }, { age: '35-39', male: -3.38, female: 3.24, }, { age: '40-44', male: -3.58, female: 3.42, }, { age: '45-49', male: -3.38, female: 3.22, }, { age: '50-54', male: -3.1, female: 2.97, }, { age: '55-59', male: -2.9, female: 2.83, }, { age: '60-64', male: -2.72, female: 2.66, }, { age: '65-69', male: -2.34, female: 2.44, }, { age: '70-74', male: -1.51, female: 1.68, }, { age: '75-79', male: -1.11, female: 1.38, }, { age: '80-84', male: -0.84, female: 1.22, }, { age: '85+', male: -0.48, female: 1.39, }, ];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>
  1. Convert half of the data source values from positive to negative. In this demo, the male percentages are negative, while the female are positive.

  2. Implement a rotated stacked bar chart. Use the commonSeriesSettings object to specify the type and the argumentField property (age in this case). Set the rotated property to true.

  3. Declare two objects in the series array: one for negative values, the other for positive. Specify the color, name, and valueField for each series.

  4. Change the label text of the valueAxis so that the negative values appear as positive. To implement this technique, use the customizeText function.

To further customize your bi-directional bar chart, implement tooltips and change the legend's alignment.

<dx-chart
id="chart"
[dataSource]="populationData"
[rotated]="true"
[barGroupWidth]="18"
title="Population Pyramid For Norway 2024"
>
<dxo-chart-common-series-settings argumentField="age" type="stackedbar">
</dxo-chart-common-series-settings>
<dxi-chart-series valueField="male" name="Male" color="#3F7FBF">
</dxi-chart-series>
<dxi-chart-series valueField="female" name="Female" color="#F87CCC">
</dxi-chart-series>
<dxo-chart-tooltip [enabled]="true" [customizeTooltip]="customizeTooltip">
</dxo-chart-tooltip>
<dxi-chart-value-axis>
<dxo-chart-label [customizeText]="customizeLabel"></dxo-chart-label>
</dxi-chart-value-axis>
<dxo-chart-legend verticalAlignment="bottom" horizontalAlignment="center">
<dxo-chart-margin [left]="50"></dxo-chart-margin>
</dxo-chart-legend>
</dx-chart>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxChartModule, DxChartTypes } from 'devextreme-angular/ui/chart';
import { Population, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxChartModule,
],
})
export class AppComponent {
populationData: Population[];
constructor(service: Service) {
this.populationData = service.getPopulationData();
}
customizeTooltip = ({ valueText }: DxChartTypes.CommonPointInfo) => ({
text: Math.abs(Number(valueText)),
});
customizeLabel: DxChartTypes.ValueAxisLabel['customizeText'] = ({ value }) => `${Math.abs(value as number)}%`;
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #chart {
height: 549px;
width: 820px;
margin: 0 auto;
}
import { Injectable } from '@angular/core';
export class Population {
age: string;
male: number;
female: number;
}
const populationData: Population[] = [{
age: '0-4',
male: -2.99,
female: 2.83,
}, {
age: '5-9',
male: -2.93,
female: 2.77,
}, {
age: '10-14',
male: -3.04,
female: 2.88,
}, {
age: '15-19',
male: -3.24,
female: 3.09,
}, {
age: '20-24',
male: -3.24,
female: 3.09,
}, {
age: '25-29',
male: -3.15,
female: 3,
}, {
age: '30-34',
male: -3.19,
female: 3.04,
}, {
age: '35-39',
male: -3.38,
female: 3.24,
}, {
age: '40-44',
male: -3.58,
female: 3.42,
}, {
age: '45-49',
male: -3.38,
female: 3.22,
}, {
age: '50-54',
male: -3.1,
female: 2.97,
}, {
age: '55-59',
male: -2.9,
female: 2.83,
}, {
age: '60-64',
male: -2.72,
female: 2.66,
}, {
age: '65-69',
male: -2.34,
female: 2.44,
}, {
age: '70-74',
male: -1.51,
female: 1.68,
}, {
age: '75-79',
male: -1.11,
female: 1.38,
}, {
age: '80-84',
male: -0.84,
female: 1.22,
}, {
age: '85+',
male: -0.48,
female: 1.39,
}];
@Injectable()
export class Service {
getPopulationData(): Population[] {
return populationData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>